package polyglot.ext.atomjava.ast;

import polyglot.ext.atomjava.types.*;
import polyglot.ext.atomjava.visit.*;
import polyglot.ext.jl.ast.ConstructorDecl_c;
import polyglot.ast.*;
import polyglot.util.*;
import polyglot.visit.*;
import polyglot.types.*;
import polyglot.ext.atomjava.util.*;
import java.util.List;
import java.util.Collections;

public class AtomJavaAtomicConstructorDecl_c 
  extends ConstructorDecl_c 
  implements AtomJavaBuild
{
  public AtomJavaAtomicConstructorDecl_c(Position pos, Flags flags, 
                                         String name, List formals, 
                                         List throwTypes, Block body) {
    super(pos, flags, name, formals, throwTypes, body);
  }

  //// this version of the constructor is always in an atomic scope
  public Context enterScope(Context c) {
    c = super.enterScope(c);
    c = ((AtomJavaContext)c).pushAtomic();
    return c;
  }
  
  public NodeVisitor buildEnter(AtomJavaBuilder ab) {
    return ab;
  }

  public Node build(Node parent, AtomJavaBuilder ab) {
    AtomJavaContext     c  = ab.context();
    AtomJavaTypeSystem  ts = ab.typeSystem();
    AtomJavaNodeFactory nf = ab.nodeFactory();

    // TO DO: Dan, if we want to catch this before any constructing then it
    //        needs to be at the new site, not here . . . super types get 
    //        constructed first
    // a run-time exception if we call new within atomic if a finalizer
    // exists (trust superclass will catch it as necessary)
    if(!c.currentClass().methods("finalize",Collections.EMPTY_LIST)
       .isEmpty()) {
      New n = 
        nf.New(c, null, nf.CanonicalTypeNode(c,ts.NewWithFinalizerInAtomic()),
               Collections.EMPTY_LIST, null);
      Throw t = nf.Throw(c, n);
      return body(nf.Block(c, AJS.List(t)));
    }

    return this;
  }

}

