package polyglot.ext.atomjava.runtime.wrapper.java.lang;

import polyglot.ext.atomjava.runtime.UndoSomething;

public class StringBuffer {
	
	//global lock for this object
	private static final polyglot.ext.atomjava.runtime.AObject sbLockHolder = new polyglot.ext.atomjava.runtime.AObject();
	
	/**
	 * New StringBuffer from a string non-atomic
	 */
	public static java.lang.StringBuffer __New(java.lang.String s) {
		synchronized (polyglot.ext.atomjava.runtime.AThread.currentThread().lock)  {
			polyglot.ext.atomjava.runtime.AThread.currentThread().revocable = true;
			polyglot.ext.atomjava.runtime.AThread.currentThread().robbed = false;
		}
		synchronized (sbLockHolder)  {
			synchronized (polyglot.ext.atomjava.runtime.AThread.currentThread().lock)  {
				polyglot.ext.atomjava.runtime.AThread.currentThread().revocable = false;
			}
			
			return new java.lang.StringBuffer(s);
		}
	}
	
	/**
	 * New StringBuffer from a string atomic
	 */
	public static java.lang.StringBuffer __aj__New(java.lang.String s) {
		synchronized (polyglot.ext.atomjava.runtime.AThread.currentThread().lock)  {
			polyglot.ext.atomjava.runtime.AThread.currentThread().revocable = true;
			polyglot.ext.atomjava.runtime.AThread.currentThread().robbed = false;
		}
		synchronized (sbLockHolder)  {
			synchronized (polyglot.ext.atomjava.runtime.AThread.currentThread().lock)  {
				polyglot.ext.atomjava.runtime.AThread.currentThread().revocable = false;
			}
			
			if (polyglot.ext.atomjava.runtime.AThread.currentThread().robbed)
				throw polyglot.ext.atomjava.runtime.AtomJavaRollBack.ROLLBACK;
			
			return new java.lang.StringBuffer(s);
		}
	}
	
	public static java.lang.StringBuffer __New() {
		synchronized (polyglot.ext.atomjava.runtime.AThread.currentThread().lock)  {
			polyglot.ext.atomjava.runtime.AThread.currentThread().revocable = true;
			polyglot.ext.atomjava.runtime.AThread.currentThread().robbed = false;
		}
		synchronized (sbLockHolder)  {
			synchronized (polyglot.ext.atomjava.runtime.AThread.currentThread().lock)  {
				polyglot.ext.atomjava.runtime.AThread.currentThread().revocable = false;
			}
			
			return new java.lang.StringBuffer();
		}
	}
	
	public static java.lang.StringBuffer __aj__New() {
		synchronized (polyglot.ext.atomjava.runtime.AThread.currentThread().lock)  {
			polyglot.ext.atomjava.runtime.AThread.currentThread().revocable = true;
			polyglot.ext.atomjava.runtime.AThread.currentThread().robbed = false;
		}
		synchronized (sbLockHolder)  {
			synchronized (polyglot.ext.atomjava.runtime.AThread.currentThread().lock)  {
				polyglot.ext.atomjava.runtime.AThread.currentThread().revocable = false;
			}
			
			if (polyglot.ext.atomjava.runtime.AThread.currentThread().robbed)
				throw polyglot.ext.atomjava.runtime.AtomJavaRollBack.ROLLBACK;
			
			return new java.lang.StringBuffer();
		}
	}
	
	public static final void append(java.lang.StringBuffer sb1, java.lang.StringBuffer sb2) {
		synchronized (polyglot.ext.atomjava.runtime.AThread.currentThread().lock)  {
			polyglot.ext.atomjava.runtime.AThread.currentThread().revocable = true;
			polyglot.ext.atomjava.runtime.AThread.currentThread().robbed = false;
		}
		synchronized (sbLockHolder)  {
			synchronized(sb1) {
				synchronized(sb2) {
					synchronized (polyglot.ext.atomjava.runtime.AThread.currentThread().lock)  {
						polyglot.ext.atomjava.runtime.AThread.currentThread().revocable = false;
					}
					//let's do the actual append now.
					sb1.append(sb2);
				}
			}
		}
	}
	
	public static final void __aj_append_(java.lang.StringBuffer sb1, java.lang.StringBuffer sb2) {
		synchronized (polyglot.ext.atomjava.runtime.AThread.currentThread().lock)  {
			polyglot.ext.atomjava.runtime.AThread.currentThread().revocable = true;
			polyglot.ext.atomjava.runtime.AThread.currentThread().robbed = false;
		}
		synchronized (sbLockHolder)  {
			synchronized(sb1) {
				//TODO: Should we grab the lock on sb2 based on the comment in the StringBuffer source saying that it only synchronizes on 
				//the destination (this) and not the source
				
				//TODO:don't need to synch on this!
				synchronized(sb2) {
					synchronized (polyglot.ext.atomjava.runtime.AThread.currentThread().lock)  {
						polyglot.ext.atomjava.runtime.AThread.currentThread().revocable = false;
					}
					
					if (polyglot.ext.atomjava.runtime.AThread.currentThread().robbed)
						throw polyglot.ext.atomjava.runtime.AtomJavaRollBack.ROLLBACK;
					
					//store backup
					java.lang.String sbContents = sb1.toString();
					UndoAppend undo = new UndoAppend(sb1, sbContents);
					polyglot.ext.atomjava.runtime.AThread.currentThread().log(undo);
					
					//actual append
					sb1.append(sb2);
				}
			}
			
		}
	}
	
	public static final void append(java.lang.StringBuffer sb, java.lang.String s) {
		synchronized (polyglot.ext.atomjava.runtime.AThread.currentThread().lock)  {
			polyglot.ext.atomjava.runtime.AThread.currentThread().revocable = true;
			polyglot.ext.atomjava.runtime.AThread.currentThread().robbed = false;
		}
		synchronized (sbLockHolder)  {
			//aquire lock for sb;
			synchronized(sb) {
				//we've grabbed the locks, so we can now set revocable to true
				synchronized (polyglot.ext.atomjava.runtime.AThread.currentThread().lock)  {
					polyglot.ext.atomjava.runtime.AThread.currentThread().revocable = false;
				}
				
				//let's do the actual append now.
				sb.append(s);
			}
		}
	}
	
	public static final void __aj_append_(java.lang.StringBuffer sb, java.lang.String s) {
		synchronized (polyglot.ext.atomjava.runtime.AThread.currentThread().lock)  {
			polyglot.ext.atomjava.runtime.AThread.currentThread().revocable = true;
			polyglot.ext.atomjava.runtime.AThread.currentThread().robbed = false;
		}
		synchronized (sbLockHolder)  {
			synchronized(sb) {
				synchronized (polyglot.ext.atomjava.runtime.AThread.currentThread().lock)  {
					polyglot.ext.atomjava.runtime.AThread.currentThread().revocable = false;
				}
				
				if (polyglot.ext.atomjava.runtime.AThread.currentThread().robbed)
					throw polyglot.ext.atomjava.runtime.AtomJavaRollBack.ROLLBACK;
				
				//store backup of sb.
				java.lang.String sbContents = sb.toString();
				UndoAppend undo = new UndoAppend(sb, sbContents);
				polyglot.ext.atomjava.runtime.AThread.currentThread().log(undo);
				
				//actual append
				sb.append(s);
			}
		}
	}
	
	public static final java.lang.String toString(java.lang.StringBuffer sb) {
		synchronized (polyglot.ext.atomjava.runtime.AThread.currentThread().lock)  {
			polyglot.ext.atomjava.runtime.AThread.currentThread().revocable = true;
			polyglot.ext.atomjava.runtime.AThread.currentThread().robbed = false;
		}
		synchronized (sbLockHolder)  {
			synchronized(sb) {
				synchronized (polyglot.ext.atomjava.runtime.AThread.currentThread().lock)  {
					polyglot.ext.atomjava.runtime.AThread.currentThread().revocable = false;
				}
				return sb.toString();
			}
		}
	}
	
	public static final java.lang.String __aj_toString_(java.lang.StringBuffer sb) {
		synchronized (polyglot.ext.atomjava.runtime.AThread.currentThread().lock)  {
			polyglot.ext.atomjava.runtime.AThread.currentThread().revocable = true;
			polyglot.ext.atomjava.runtime.AThread.currentThread().robbed = false;
		}
		synchronized (sbLockHolder)  {
			synchronized(sb) {
				synchronized (polyglot.ext.atomjava.runtime.AThread.currentThread().lock)  {
					polyglot.ext.atomjava.runtime.AThread.currentThread().revocable = false;
				}
				
				if (polyglot.ext.atomjava.runtime.AThread.currentThread().robbed)
					throw polyglot.ext.atomjava.runtime.AtomJavaRollBack.ROLLBACK;
				
				return sb.toString();
			}
		}
	}
	
	private static class UndoAppend extends UndoSomething {
		java.lang.StringBuffer sbPtr;
		java.lang.String sbContents;
		
		public UndoAppend(java.lang.StringBuffer sbPtr, java.lang.String sbContents) {
			this.sbPtr = sbPtr;
			this.sbContents = sbContents;
		}
		
		public void undo() {
			sbPtr.setLength(0);
			sbPtr.append(sbContents);
		}
	}
}
