package polyglot.ext.atomjava.util;

import polyglot.types.*;
import polyglot.ast.*;
import polyglot.ext.jl.types.*;
import polyglot.util.*;
import java.util.*;

public class AJS {

  public static Binary.Operator ConvertOperator(Assign.Operator op) {
    if(op == Assign.ADD_ASSIGN) return Binary.ADD;
    if(op == Assign.SUB_ASSIGN) return Binary.SUB;
    if(op == Assign.MUL_ASSIGN) return Binary.MUL;
    if(op == Assign.DIV_ASSIGN) return Binary.DIV;
    if(op == Assign.MOD_ASSIGN) return Binary.MOD;
    if(op == Assign.BIT_AND_ASSIGN) return Binary.BIT_AND;
    if(op == Assign.BIT_OR_ASSIGN)  return Binary.BIT_OR;
    if(op == Assign.BIT_XOR_ASSIGN) return Binary.BIT_XOR;
    if(op == Assign.SHL_ASSIGN)  return Binary.SHL;
    if(op == Assign.SHR_ASSIGN)  return Binary.SHR;
    if(op == Assign.USHR_ASSIGN) return Binary.USHR;
    throw new UnknownError("found unknown op: " + op.toString());
  }

  public static String OperatorString(Binary.Operator op) {
    if(op == Binary.ADD) return "add";
    if(op == Binary.SUB) return "sub";
    if(op == Binary.MUL) return "mul";
    if(op == Binary.DIV) return "div";
    if(op == Binary.MOD) return "mod";
    if(op == Binary.BIT_AND) return "bit_and";
    if(op == Binary.BIT_OR)  return "bit_or";
    if(op == Binary.BIT_XOR) return "bit_xor";
    if(op == Binary.SHL)  return "shl";
    if(op == Binary.SHR)  return "shr";
    if(op == Binary.USHR) return "ushr";
    throw new UnknownError("found unknown op: " + op.toString());
  }

  public static List List(Object... args) {
    List list = new LinkedList();
    for(Object arg: args)
      list.add(arg);
    return list;
  }

  public static List TypeNode_to_Type(List l) {
    List lst = new LinkedList();
    for(Iterator i = l.iterator(); i.hasNext();)
      lst.add(((TypeNode)i.next()).type());
    return lst;
  }

  public static List Expr_to_Type(List l) {
    List lst = new LinkedList();
    for(Iterator i = l.iterator(); i.hasNext();)
      lst.add(((Expr)i.next()).type());
    return lst;
  }

  public static List Formal_to_Type(List l) {
    List lst = new LinkedList();
    for(Iterator i = l.iterator(); i.hasNext();)
      lst.add(((Formal)i.next()).declType());
    return lst;
  }

  /* for when you have immutable lists */
  public static <T> List cons(T t, List list) {
    list.add(0, t);
    return list;
  }

  public static <T> List append(List list, T t) {
    list.add(t);
    return list;
  }

  public static <T> List typed_cons(Class c, T t, List l) {
    throw new InternalCompilerError("AJS.typed_cons is unimplemented");
  }
}
